%define pname pcomplete
%define pversion 1.1.6

%{expand:%%define emacs_version %(rpm -q emacs|sed 's/emacs-\([0-9].*\)-.*$/\1/')}
%{expand:%%define xemacs_version %(rpm -q xemacs|sed 's/xemacs-\([0-9].*\)-.*$/\1/')}

Summary:	An Emacs command shell
Name:		eshell
Version:	2.3.2
Release:	5mdk

Source0:	%name.tar.bz2
Patch:		eshell-XEmacs-and-ange-ftp.patch.bz2

License:	GPL
Group:		Shells
Url:		http://www.gci-net.com/users/j/johnw/eshell.html
BuildRoot:	%_tmppath/%name-%version-%release-root
BuildRequires:	emacs xemacs

%package emacs
Summary:	An Emacs command shell
Group:		Editors
Requires:	emacs = %{emacs_version}, emacs-%{pname}
Obsoletes:	%{name}

%package xemacs
Summary:	An XEmacs command shell
Group:		Editors
Requires:	xemacs = %{xemacs_version}, xemacs-%{pname}

%package -n emacs-%{pname}
Summary:	Programmable completion for Emacs
Group:		Editors
Requires:	emacs = %{emacs_version}

%package -n xemacs-%{pname}
Summary:	Programmable completion for XEmacs
Group:		Editors
Requires:	xemacs = %{xemacs_version}

%description

%description emacs
eshell is a command shell implemented entirely in Emacs Lisp.  It
invokes no external processes beyond those requested by the user.  It
is intended to be a functional replacement for command shells such as
bash, zsh, rc, 4dos; since Emacs itself is capable of handling most
of the tasks accomplished by such tools.

%description xemacs
eshell is a command shell implemented entirely in XEmacs Lisp.  It
invokes no external processes beyond those requested by the user.  It
is intended to be a functional replacement for command shells such as
bash, zsh, rc, 4dos; since XEmacs itself is capable of handling most
of the tasks accomplished by such tools.

%description -n emacs-%{pname}
Pcomplete provides a facility for using programmatic completion in
Emacs. It is especially useful for utilities like shells and command
interpretors, but can in fact be used anywhere within Emacs.

%description -n xemacs-%{pname}
Pcomplete provides a facility for using programmatic completion in
XEmacs. It is especially useful for utilities like shells and command
interpretors, but can in fact be used anywhere within XEmacs.

%prep

%setup -q -n %{name}
tar xfz %{name}.tar.gz
tar xfz %{pname}-%{pversion}.tar.gz
mv  %{name}-%{version}  %{name}
mv %{pname}-%{pversion} %{pname}

%patch0 -p1

# save it before distclean
mv %{name}/%{name}.info .

%build
for p in %{name} %{pname}; do
    make -C $p distclean
    make -C $p EMACS=emacs docdir=%{_docdir} infodir=%{_infodir} datadir=%{_datadir}
    install -d elc-emacs-$p
    cp -f $p/*.elc elc-emacs-$p
done

for p in %name %pname; do
    make -C $p distclean
    make -C $p EMACS=xemacs docdir=%_docdir infodir=%_infodir datadir=%_datadir
    install -d elc-xemacs-$p
    cp -f $p/*.elc elc-xemacs-$p
done

%install
for e in xemacs emacs; do
  for p in %{name} %{pname}; do
    install -d $RPM_BUILD_ROOT%{_datadir}/$e/site-lisp/$p
    install -m 644 elc-$e-$p/*.elc $p/{_pkg,auto-autoloads,*-auto}.el $RPM_BUILD_ROOT%{_datadir}/$e/site-lisp/$p
  done
  install -d $RPM_BUILD_ROOT%{_sysconfdir}/emacs/site-start.d
  cat <<EOF >$RPM_BUILD_ROOT%{_sysconfdir}/emacs/site-start.d/%{name}-$e.el
(add-to-list 'load-path "%{_datadir}/$e/site-lisp/%{name}")
(require '%{name}-auto)
EOF
  cat <<EOF >$RPM_BUILD_ROOT%{_sysconfdir}/emacs/site-start.d/%{pname}-$e.el
(add-to-list 'load-path "%{_datadir}/$e/site-lisp/%{pname}")
EOF
done

install -D -m644 %{name}.info $RPM_BUILD_ROOT%{_infodir}/%{name}.info

%post emacs
%_install_info %{name}.info

%post xemacs
%_install_info %{name}.info

%preun emacs
%_remove_install_info %{name}.info

%preun xemacs
%_remove_install_info %{name}.info

%clean
rm -fr %buildroot

%files emacs
%defattr(-,root,root)
%doc %{name}/NEWS %{name}/FEATURES
%{_infodir}/%{name}*
%{_datadir}/emacs/site-lisp/%{name}
%config(noreplace) %{_sysconfdir}/emacs/site-start.d/%{name}-emacs*

%files xemacs
%defattr(-,root,root)
%doc %{name}/NEWS %{name}/FEATURES
%{_infodir}/%{name}*
%{_datadir}/xemacs/site-lisp/%{name}
%config(noreplace) %{_sysconfdir}/emacs/site-start.d/%{name}-xemacs*

%files -n emacs-%{pname}
%defattr(-,root,root)
%doc %{pname}/README
%{_datadir}/emacs/site-lisp/%{pname}
%config(noreplace) %{_sysconfdir}/emacs/site-start.d/%{pname}-emacs*

%files -n xemacs-%{pname}
%defattr(-,root,root)
%doc %{pname}/README
%{_datadir}/xemacs/site-lisp/%{pname}
%config(noreplace) %{_sysconfdir}/emacs/site-start.d/%{pname}-xemacs*

%changelog
* Sat Mar 17 2001 David BAUDENS <baudens@mandrakesoft.com> 2.3.2-5mdk
- Fix build

* Wed Dec 13 2000 Pixel <pixel@mandrakesoft.com> 2.3.2-4mdk
- add eshell-emacs obsoletes eshell

* Tue Dec 12 2000 Pixel <pixel@mandrakesoft.com> 2.3.2-3mdk
- build for both emacs and xemacs

* Mon Nov 27 2000 Pixel <pixel@mandrakesoft.com> 2.3.2-2mdk
- add BuildRequires

* Sun Oct 15 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.3.2-1mdk
- Adjust URL.
- pcomplete 1.1.6.
- eshell 2.3.2.

* Tue Aug 22 2000 Pixel <pixel@mandrakesoft.com> 2.3-1mdk
- first spec
